# Pokéscreader for SV

ポケットモンスタースカーレット・バイオレット
(以下, ポケモン SV) 向けスクリーン読み取りツール.

[OBS Studio](https://obsproject.com/ja) からポケモン SV の対戦画面を読み取り,
[棒読みちゃん](https://chi.usamimi.info/Program/Application/BouyomiChan/) で情報を読み上げます.
用途として以下を想定しています.

- 視覚情報が使えないプレイヤーのプレイング補助
- 視覚情報だけでは情報把握が難しい対戦初心者のプレイング補助
- 対戦配信における音声情報の拡充によるコンテンツ強化

このドキュメントは, バージョン固有な情報を記録する目的で記述されており,
必要最小限の情報のみを記述しています. 詳しい解説は
[公式サイト](https://takosavi.net/pokescreader-sv/development)
をご確認ください.

## 動作環境

### パソコンの動作条件

- Windows 日本語版
- ゲーム映像を取り込むキャプチャボード
- OBS Studio (28.0.0 以上)
    - キャプチャボードを映像キャプチャデバイスとして取り込んであること
- 棒読みちゃん (HTTP 連携機能があるバージョン)

### ゲームの条件

- 日本語セーブデータ
- 対プレイヤー戦
- シングルバトル

## 事前準備

ここには必要要件だけ記載しています. 詳しい手順は公式サイトの
[導入方法](http://localhost:3000/pokescreader-sv/get-started)
を参照してください.

- ポケモンの設定で「話のはやさ」を「はやい」に設定する.
- OBS Studio の WebSocket サーバを認証ありで起動する.
- 棒読みちゃんの HTTP 連携をポート `50080` で起動する. (初期状態ではできているはず)
- 以下の内容のテキストファイルを `settings.toml` という名前で作成する. (文字コードは UTF-8)

```
[obs]
port = OBS WebSocket サーバーポートの値
password = "OBS Websocket サーバーパスワードの値 (二重引用符で括る)"
source = "OBS 映像キャプチャデバイスの名前 (二重引用符で括る)"
```

準備ができたら `pokescreader-sv.exe` を起動します.

## ツールの使い方

実装されている機能の詳細は
[機能リファレンス](http://localhost:3000/pokescreader-sv/reference)
を参照してください. このバージョンで実装されている機能は次の通りです.

### 自動で起動する機能

#### シーン遷移通知

- 選出開始
- 選出終了
- 指示開始

#### 自動読み上げ

- 相手チーム
- 相手 HP 割合
- 味方 HP 現在値, 割合
- ログメッセージ
- テラスタイプ

## 手動で操作する機能

- 相手チーム確認 (O キー)
- 相手チームのタイプ確認 (T キー)
- 相手 HP 確認 (H キー)
- 味方 HP 確認 (A キー)
- 技を読み取り (M キー, 技選択画面またはポケモン選択画面のみ)
- 選択中の技を読み取り (C キー, 技選択画面のみ)
- スクリーンショット保存 (1 キー)

## 設定ファイルの追加設定

- `bouyomichan` セクション
    - `speed`: 読み上げスピード設定 (デフォルト: 150)
    - `notifies_log`: ログメッセージを読み上げるか (デフォルト: true)
    - `notifies_tera_type`: テラスタイプを読み上げるか (デフォルト: true)
- `gui` セクション
    - `uses_buttons`: ボタンを表示するかどうか (デフォルト: true)

### 把握している不具合

- シーン遷移通知
    - 技選択で使用できない技 (「ちょうはつ」やこだわりアイテムで制限されている場合など)
      を連打すると, 「指示開始」 と通知されることがあります.
- 相手チーム読み上げ
    - 6 匹ではないチームを読み上げるとき、稀に存在しないポケモンの名前を読み上げることがあります.
    - 「デンヂムシ」を他のポケモンの名前で読み上げることがあります.
- 相手 HP 割合読み上げ
    - 食べ残しの回復ダメージなど, HP ゲージエフェクトの表示時間が極めて短い場合,
      HP 割合の読み上げができなかったり, 数値が不正確になったりすることがあります.
    - 条件は調査中ですが, 一部の技で相手を倒したとき, ゼロではない値で発話することがあります.
    - 高頻度にダメージが発生する連続技を使うと, 発話が追いつかないことがあります.
- ログメッセージ読み上げ
    - パーティ選択画面の前後で余計な発話をすることがあります.
    - 選出画面に遷移する直前で余計な発話をすることがあります.
    - 行動中の画面表示が想定外の状態になると, ログメッセージを読み上げなくなることがあります.
- テラスタイプ読み上げ
    - 「テラスタイプドラゴン」を「テラスタイプひこう」と頻繁に間違える傾向があります.
    - 「テラスタイプこおり」を他のタイプと混同することがあります. 
    - カバルドンなど, 前にせり出したポケモンのテラスタイプ判定が不安定になることがあります.
    - 飛行テラバーストを使用するとテラスタイプを読み上げることがあります.
- 技読み上げ
    - 「さいきのいのり」の PP 読み上げが失敗することがあります.
- 選択中の技読み上げ
    - 残り PP が 0 になった技を選択しているとき, 読み上げが失敗します.

## 免責事項

テンプレなお約束ですが, 本アプリの使用によって生じた不利益には関知しません. 自己責任でご利用ください.
特に, 通知内容はできるだけ正確になるよう努めていますが, 間違いを起こすこともあります.
あくまでも参考情報として扱ってください.

# 作者

もち

- X: [@takosavi](https://x.com/takosavi)
- Blog: https://takosavi.hatenablog.com/
- Twitch: https://www.twitch.tv/mochitakosavi
